''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'    SIMULATION OF THE ACTION POTENTIAL OF THE SQUID GIANT AXON              '
'         AFTER HODGKIN & HUXLEY, J. PHYSIOL. 117:500 (1952).                '
'                                                                            '
'    Written by Stephen W. Jones, 2/11/87; updated 2/25/89.                  '
'         Written for IBM PC-compatibles, using QuickBASIC 4.5.              '
'         Requires EGA, CGA, Hercules, or AT&T graphics adapter.             '
'                                                                            '
'    AXOVACS1.BAS                                                            '
'                                                                            '
'    Program for printing introductory text, and selecting one of            '
'         the simulations available.                                         '
'    Introductory version.                                                   '
'                                                                            '
'    In this version, parameters are passed by writing to a 16 byte          '                                        
'         communication area in memory.                                      '
'                                                                            '
'    Include files:                                                          '
'         GRAPHICS.INC (contains subroutine Graphics and error traps)        '
'         POKEINFO.INC (writes parameters to memory)                         '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	    
		Called$ = "AXOVACS1"

		True = -1
		False = NOT (True)       'Allow logical if.

	GOSUB Graphics
	GOSUB IntroText               'Print introductory text

choose:                            'Ask for choice of simulation (or quit)
	DO
	LOOP WHILE INKEY$ <> ""                 'First, flush keyboard buffer
    
	Row = 24
	LOCATE Row, 1
	PRINT "Enter your choice (1, 2, 3, 4, 5, or 0)";
	Column = POS(0) + 2
	INPUT ; Choice$
	Sim% = VAL(Choice$)
	SELECT CASE Sim%
		CASE 1
			Simulation% = 5          'Action potential
			GOSUB PokeInfo
			CLEAR
			CHAIN "ACTION"
		CASE 2
			Simulation% = 6          'Expanded scales
			GOSUB PokeInfo
			CLEAR
			CHAIN "ACTION"
		CASE 3
			Simulation% = 7          'Pharmacology
			GOSUB PokeInfo
			CLEAR
			CHAIN "ACTION"
		CASE 4
			Simulation% = 2          'Conductances
			GOSUB PokeInfo
			CLEAR
			CHAIN "VCLAMP"
		CASE 5
			Simulation% = 1          'Single channels
			GOSUB PokeInfo
			CLEAR
			CHAIN "CHANNEL"
		CASE ELSE
			IF Choice$ = "0" THEN
				SCREEN 0            'If a '0' actually entered,
				CLS
				Simulation% = 0
				Called$ = ""
				GOSUB PokeInfo
				CLEAR
				END                      'exit to DOS,
			ELSE
				FOR i = Column TO 80
					LOCATE Row, i
					PRINT " ";
				NEXT i
				SOUND 260, 1
				GOTO choose              'otherwise try again.
			END IF
	END SELECT

	END

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'    $INCLUDE: 'graphics.inc'

'    $INCLUDE: 'pokeinfo.inc'

IntroText:
	CLS
	LOCATE 1, 14
	IF Ega THEN COLOR Blue
	PRINT "AXOVACS Electrophysiology Computer Lab - Version 2.0"
	LOCATE , 24
	PRINT "(C) 1989 Axon Instruments, Inc."
	IF Ega THEN COLOR White
	PRINT
	PRINT "     A computer simulation, based on the model proposed by Hodgkin & Huxley"
	PRINT "[J. Physiol. 117:500 (1952)] for generation of the action potential in the"
	PRINT "squid giant axon."
	PRINT
	IF Ega THEN COLOR Green
	PRINT "Six options are available:"
	PRINT
	IF Ega THEN COLOR White
	PRINT "    (1)  Action potential    (The basic simulation)"
	PRINT
	PRINT "    (2)  Expanded scales     (A close look at threshold)"
	PRINT
	PRINT "    (3)  Pharmacology        (Specific blockade of Na or K channels)"
	PRINT
	PRINT "    (4)  Voltage clamp       (Na and K conductances)"
	PRINT
	PRINT "    (5)  Channels            (Single channel gating)"
	PRINT
	PRINT
	PRINT "OR: (0)  Quit                (Exit to computer's operating system)"

	RETURN

