''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'    PARAMA.BAS                                                              '
'                                                                            '
'    Main parameter editing routine for ACTION.BAS                           '
'                                                                            '
'    Latest revision 1/15/89 by Stephen W. Jones                             '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'    $INCLUDE: 'declares.inc'

SUB NewParameters STATIC           'Main parameter input and display routine
     SHARED Ega, HiRes, White, Yellow, Blue, Green
     SHARED Simulation%, Called$
     SHARED ReInit, Esc$, MenuN, OutputMenuN
     SHARED PrintDefaultAt
     SHARED Parameter()
     SHARED TimeOption(), IntervalOption()
     SHARED xChar, yChar
     SHARED True, False
     SHARED BackSpace$, Enter$, Down$, Up$, Cursor$, Tab$
     SHARED PgDown$, PgUp$, Home$, End$, F2$, F3$, Null$
     SHARED UpArrow$, DownArrow$
     SHARED RightArrow$, LeftArrow$
     SHARED RightKey$, LeftKey$, Del$, Ins$
     SHARED xG, yG, InsertMode

     IF NOT DoneAlready THEN
          GOSUB Dimensions
          GOSUB DefineKeys
          GOSUB MakeParameterArrays
     END IF
   
     Parameter(2, 5) = False                 'ClearNext: Starts false each run
     Parameter(5, 9) = False                 'ClearNext: Starts false each run
     Parameter(6, 9) = False                 'ClearNext: Starts false each run
     Parameter(7, 9) = False                 'ClearNext: Starts false each run
     Parameter(8, 8) = False                 'ClearNext: Starts false each run
         
     MenuOnScreen = False                    'When false, save screen
     RunNow = False                          'When true, do new run
    
     OutputMenuN = 9                         'These affect menu switches
     LastMenuN = 13                               'new advanced menus
     ExtraValues = 3                              'Display menu numbering odd
    
     IF Simulation% >= 5 AND Simulation% <= 8 THEN Simple = True
     IF Simple THEN
          CALL Parameters                         'If simplified version,
          CALL SimulationInstructions
anotherKey:
          InputKey$ = ""
          DO WHILE LEN(InputKey$) = 0
               InputKey$ = INKEY$
          LOOP
          SELECT CASE LCASE$(InputKey$)
               CASE "r", F3$                           '<r> = run
                    EXIT SUB
               CASE "q", Esc$                          '<Esc> = main menu
                    GOSUB QuitMenu
               CASE "c"                                '<c> = clear screen
                    MenuOnScreen = False
                    CLS
                    CALL Axes                              'rewrite axes
                    CALL Parameters                        'rewrite text
                    CALL SimulationInstructions
               CASE "i"                                'reset values to defaults
                    ReInit = True
                    EXIT SUB
               CASE "e", F2$                           '<e> = edit parameters
                    GOSUB CondensedMenu
                    IF RunNow THEN
                         EXIT SUB                           'run, or
                    ELSE CALL Parameters
                         CALL SimulationInstructions        'rewrite options
                    END IF
               CASE ELSE                               'ignore other keys
          END SELECT
     GOTO anotherKey
     END IF

     CALL MenuInstructions                   'Print text for advanced menus
doAgain:
     SELECT CASE NextMenu                    'First, test for menu switch
          CASE 2
               NextMenu = 0
               GOSUB DisplayMenu                  'to Display
          CASE 3
               NextMenu = 0
               GOSUB StimuliMenu                  'to Stimuli
          CASE 4
               NextMenu = 0
               GOSUB PharmacologyMenu             'to Pharmacology
          CASE OutputMenuN
               NextMenu = 0
               GOSUB OutputMenu                   'to Outputs
          CASE 10
               NextMenu = 0
               GOSUB MeasureMenu                  'to Measurements
          CASE 11
               NextMenu = 0
               GOSUB nMenu                        'to Potassium kinetics
          CASE 12
               NextMenu = 0
               GOSUB mMenu                        'to Sodium activation
          CASE 13
               NextMenu = 0
               GOSUB hMenu                        'to Sodium inactivation
          CASE ELSE
     END SELECT                              'Get new menu choice
     IF NextMenu <> 0 GOTO doAgain                'if not selected already.
     
     IF RunNow THEN EXIT SUB                 'Run (triggered from a menu)

     InputKey$ = ""
     DO WHILE LEN(InputKey$) = 0             'Ask for choice of menus
          InputKey$ = INKEY$
     LOOP
     SELECT CASE LCASE$(InputKey$)                'Go to appropriate menu,
          CASE "d", "e", F2$
               GOSUB DisplayMenu                       'Display
          CASE "s"
               GOSUB StimuliMenu                       'Stimuli
          CASE "p"
               GOSUB PharmacologyMenu                  'Pharmacology
          CASE "o"
               GOSUB OutputMenu                        'Output
          CASE "a"
               GOSUB MeasureMenu                       'Measurements
          CASE "n"
               GOSUB nMenu                             'Potassium activation
          CASE "m"
               GOSUB mMenu                             'Sodium activation
          CASE "h"
               GOSUB hMenu                             'Sodium inactivation
          CASE "r", F3$                           'or do a run
               EXIT SUB
          CASE "q", Esc$                          'quit or chain another
               GOSUB QuitMenu
          CASE "v"                                'print parameter list
               CALL Parameters
          CASE SpaceBar$, Enter$, F1$             'print hot key list
               CALL MenuInstructions
          CASE "c"                                'clear screen
               MenuOnScreen = False
               CLS
               CALL Axes                              'rewrite axes, text
               CALL MenuInstructions
          CASE "i"                                'reset values to defaults
               ReInit = True
               EXIT SUB
          CASE ELSE
     END SELECT

     GOTO doAgain                            'get next key.
  
     EXIT SUB

'    $INCLUDE: 'param.inc'

MakeParameterArrays:
     InputLine(2, 1) = 5                     'Display menu
     InputLine(2, 2) = 6
     InputLine(2, 3) = 9
     InputLine(2, 4) = 10
     InputLine(2, 5) = 11
     InputLine(2, 6) = 14
     InputLine(2, 7) = 17
     InputLine(2, 8) = 18
 
     ParameterToErase(2, 1) = 1                   'for rewriting edited values
     ParameterToErase(2, 2) = 1
     ParameterToErase(2, 3) = 3
     ParameterToErase(2, 4) = 3
     ParameterToErase(2, 5) = 3
     LinesToErase(2, 1) = 2
     LinesToErase(2, 2) = 2
     LinesToErase(2, 3) = 3
     LinesToErase(2, 4) = 3
     LinesToErase(2, 5) = 3
     LinesToErase(2, 6) = 1
     LinesToErase(2, 7) = 1
     LinesToErase(2, 8) = 1
  
     FOR i = 1 TO 18
          CursorStart(2, i) = OptionCol(0)
          ParameterType(2, i) = OptionType
     NEXT i
     ParameterType(2, 6) = MultipleType
 
     TimeOption(1) = 1                            'Available time scales, and
     TimeOption(2) = 2.5
     TimeOption(3) = 5
     TimeOption(4) = 10
     TimeOption(5) = 25
     TimeOption(6) = 50
     TimeOption(7) = 100
     TimeOption(8) = 250
     TimeOption(9) = 500
     TimeOption(10) = 1000
     IntervalOption(1) = 500                           '# of calculations
     IntervalOption(2) = 500
     IntervalOption(3) = 500
     IntervalOption(4) = 500
     IntervalOption(5) = 1000
     IntervalOption(6) = 30 * TimeOption(6)
     IntervalOption(7) = 30 * TimeOption(7)
     IntervalOption(8) = 30 * TimeOption(8)
     IntervalOption(9) = 30 * TimeOption(9)
     IntervalOption(10) = 30 * TimeOption(10)

     InputLine(3, 1) = 5                     'Stimuli menu
     InputLine(3, 2) = 8
     InputLine(3, 3) = 9
     InputLine(3, 4) = 10
     InputLine(3, 5) = 13
     InputLine(3, 6) = 14
     InputLine(3, 7) = 15
     UpperL(3, 1) = 100
     LowerL(3, 1) = -200
     UpperL(3, 2) = 2000
     LowerL(3, 2) = -5000
     UpperL(3, 3) = 1000
     LowerL(3, 3) = 0
     UpperL(3, 4) = 1000
     LowerL(3, 4) = 0
     UpperL(3, 5) = 2000
     LowerL(3, 5) = -5000
     UpperL(3, 6) = 1000
     LowerL(3, 6) = 0
     UpperL(3, 7) = 1000
     LowerL(3, 7) = 0
 
     FOR i = 1 TO 7
          ParameterType(3, i) = ValueType
     NEXT i
    
     InputLine(4, 1) = 5                     'Pharmacology menu
     InputLine(4, 2) = 6
     InputLine(4, 3) = 7
     InputLine(4, 4) = 13
     InputLine(4, 5) = 14
     InputLine(4, 6) = 17
     UpperL(4, 1) = 10000
     LowerL(4, 1) = 0
     UpperL(4, 2) = 10000
     LowerL(4, 2) = 0
     UpperL(4, 3) = 100
     LowerL(4, 3) = 0
     UpperL(4, 4) = 1000
     LowerL(4, 4) = .001
     UpperL(4, 5) = 1000
     LowerL(4, 5) = .001

     FOR i = 1 TO 5
          ParameterType(4, i) = ValueType
     NEXT i
     ParameterType(4, 6) = OptionType
     CursorStart(4, 6) = OptionCol(0)

     InputLine(5, 1) = 5                     'Action potential menu
     InputLine(5, 2) = 8
     InputLine(5, 3) = 9
     InputLine(5, 4) = 10
     InputLine(5, 5) = 13
     InputLine(5, 6) = 14
     InputLine(5, 7) = 15
     InputLine(5, 8) = 17
     InputLine(5, 9) = 18

     UpperL(5, 1) = 60
     LowerL(5, 1) = -120
     UpperL(5, 2) = 2000
     LowerL(5, 2) = -2000
     UpperL(5, 3) = 1000
     LowerL(5, 3) = 0
     UpperL(5, 4) = 1000
     LowerL(5, 4) = 0
     UpperL(5, 5) = 2000
     LowerL(5, 5) = -2000
     UpperL(5, 6) = 1000
     LowerL(5, 6) = 0
     UpperL(5, 7) = 1000
     LowerL(5, 7) = 0

     CursorStart(5, 8) = OptionCol(0)
     CursorStart(5, 9) = OptionCol(0)

     FOR i = 1 TO 7
          ParameterType(5, i) = ValueType
     NEXT i
     ParameterType(5, 8) = OptionType
     ParameterType(5, 9) = OptionType
 
     InputLine(6, 1) = 5                     'Expanded scales menu
     InputLine(6, 2) = 8
     InputLine(6, 3) = 9
     InputLine(6, 4) = 10
     InputLine(6, 5) = 13
     InputLine(6, 6) = 14
     InputLine(6, 7) = 15
     InputLine(6, 8) = 17
     InputLine(6, 9) = 18

     UpperL(6, 1) = 60
     LowerL(6, 1) = -120
     UpperL(6, 2) = 2000
     LowerL(6, 2) = -2000
     UpperL(6, 3) = 1000
     LowerL(6, 3) = 0
     UpperL(6, 4) = 1000
     LowerL(6, 4) = 0
     UpperL(6, 5) = 2000
     LowerL(6, 5) = -2000
     UpperL(6, 6) = 1000
     LowerL(6, 6) = 0
     UpperL(6, 7) = 1000
     LowerL(6, 7) = 0
 
     CursorStart(6, 8) = OptionCol(0)
     CursorStart(6, 9) = OptionCol(0)

     FOR i = 1 TO 7
          ParameterType(6, i) = ValueType
     NEXT i
     ParameterType(6, 8) = OptionType
     ParameterType(6, 9) = OptionType
           
     InputLine(7, 1) = 5                     '"Drug" menu
     InputLine(7, 2) = 8
     InputLine(7, 3) = 9
     InputLine(7, 4) = 10
     InputLine(7, 5) = 13
     InputLine(7, 6) = 14
     InputLine(7, 7) = 15
     InputLine(7, 8) = 17
     InputLine(7, 9) = 18

     UpperL(7, 1) = 60
     LowerL(7, 1) = -120
     UpperL(7, 2) = 2000
     LowerL(7, 2) = -5000
     UpperL(7, 3) = 1000
     LowerL(7, 3) = 0
     UpperL(7, 4) = 1000
     LowerL(7, 4) = 0
     UpperL(7, 5) = 10000
     LowerL(7, 5) = 0
     UpperL(7, 6) = 10000
     LowerL(7, 6) = 0
     UpperL(7, 7) = 100
     LowerL(7, 7) = 0

     CursorStart(7, 8) = OptionCol(0)
     CursorStart(7, 9) = OptionCol(0)

     FOR i = 1 TO 7
          ParameterType(7, i) = ValueType
     NEXT i
     ParameterType(7, 8) = OptionType
     ParameterType(7, 9) = OptionType

     InputLine(8, 1) = 5                     'Ionic menu
     InputLine(8, 2) = 8
     InputLine(8, 3) = 9
     InputLine(8, 4) = 10
     InputLine(8, 5) = 14
     InputLine(8, 6) = 15
     InputLine(8, 7) = 17
     InputLine(8, 8) = 18
  
     UpperL(8, 1) = 60
     LowerL(8, 1) = -120
     UpperL(8, 2) = 2000
     LowerL(8, 2) = -2000
     UpperL(8, 3) = 1000
     LowerL(8, 3) = 0
     UpperL(8, 4) = 1000
     LowerL(8, 4) = 0
     UpperL(8, 5) = 1000
     LowerL(8, 5) = .001
     UpperL(8, 6) = 1000
     LowerL(8, 6) = .001

     CursorStart(8, 7) = OptionCol(0)
     CursorStart(8, 8) = OptionCol(0)

     FOR i = 1 TO 6
          ParameterType(8, i) = ValueType
     NEXT i
     ParameterType(8, 7) = OptionType
     ParameterType(8, 8) = OptionType

     InputLine(9, 1) = 7                'Output menu
     InputLine(9, 2) = 8
     InputLine(9, 3) = 9
     FOR i = 1 TO 3
          ParameterType(9, i) = OptionType
          CursorStart(9, i) = OptionCol(0)
     NEXT i
  
     ParameterToErase(9, 1) = 1
     ParameterToErase(9, 2) = 1
     ParameterToErase(9, 3) = 1
     LinesToErase(9, 1) = 3
     LinesToErase(9, 2) = 3
     LinesToErase(9, 3) = 3

     FOR i = 1 TO 8                     'Measurements menu
          ParameterType(10, i) = ValueType
     NEXT i
     InputLine(10, 1) = 5
     InputLine(10, 2) = 6
     InputLine(10, 3) = 9
     InputLine(10, 4) = 10
     InputLine(10, 5) = 13
     InputLine(10, 6) = 14
     InputLine(10, 7) = 17
     InputLine(10, 8) = 18
     FOR i = 1 TO 8
          LowerL(10, i) = 0
          UpperL(10, i) = 1000
     NEXT i
    
     FOR i = 1 TO 9                     'n kinetics menu
          ParameterType(11, i) = ValueType
     NEXT i
     ParameterType(11, 6) = OptionType
     CursorStart(11, 6) = OptionCol(0)
                             
     InputLine(11, 1) = 4
     InputLine(11, 2) = 5
     InputLine(11, 3) = 8
     InputLine(11, 4) = 9
     InputLine(11, 5) = 10
     InputLine(11, 6) = 11
     InputLine(11, 7) = 14
     InputLine(11, 8) = 15
     InputLine(11, 9) = 16

     LowerL(11, 1) = 0
     UpperL(11, 1) = 1000
     LowerL(11, 2) = 0
     UpperL(11, 2) = 100
     LowerL(11, 3) = 0
     UpperL(11, 3) = 1000
     LowerL(11, 4) = -200
     UpperL(11, 4) = 200
     LowerL(11, 5) = -10000
     UpperL(11, 5) = 10000
     LowerL(11, 7) = 0
     UpperL(11, 7) = 1000
     LowerL(11, 8) = -200
     UpperL(11, 8) = 200
     LowerL(11, 9) = -10000
     UpperL(11, 9) = 10000

     FOR i = 1 TO 9                     'm kinetics menu
          ParameterType(12, i) = ValueType
     NEXT i
     ParameterType(12, 6) = OptionType
     CursorStart(12, 6) = OptionCol(0)

     InputLine(12, 1) = 4
     InputLine(12, 2) = 5
     InputLine(12, 3) = 8
     InputLine(12, 4) = 9
     InputLine(12, 5) = 10
     InputLine(12, 6) = 11
     InputLine(12, 7) = 14
     InputLine(12, 8) = 15
     InputLine(12, 9) = 16

     LowerL(12, 1) = 0
     UpperL(12, 1) = 1000
     LowerL(12, 2) = 0
     UpperL(12, 2) = 100
     LowerL(12, 3) = 0
     UpperL(12, 3) = 1000
     LowerL(12, 4) = -200
     UpperL(12, 4) = 200
     LowerL(12, 5) = -10000
     UpperL(12, 5) = 10000
     LowerL(12, 7) = 0
     UpperL(12, 7) = 1000
     LowerL(12, 8) = -200
     UpperL(12, 8) = 200
     LowerL(12, 9) = -10000
     UpperL(12, 9) = 10000
                     
     FOR i = 1 TO 9                     'h kinetics menu
          ParameterType(13, i) = ValueType
     NEXT i
     ParameterType(13, 8) = OptionType
     CursorStart(13, 8) = OptionCol(0)

     InputLine(13, 1) = 4
     InputLine(13, 2) = 7
     InputLine(13, 3) = 8
     InputLine(13, 4) = 9
     InputLine(13, 5) = 12
     InputLine(13, 6) = 13
     InputLine(13, 7) = 14
     InputLine(13, 8) = 15
     InputLine(13, 9) = 18

     LowerL(13, 1) = 0
     UpperL(13, 1) = 100
     LowerL(13, 2) = 0
     UpperL(13, 2) = 1000
     LowerL(13, 3) = -200
     UpperL(13, 3) = 200
     LowerL(13, 4) = -10000
     UpperL(13, 4) = 10000
     LowerL(13, 5) = 0
     UpperL(13, 5) = 1000
     LowerL(13, 6) = -200
     UpperL(13, 6) = 200
     LowerL(13, 7) = -10000
     UpperL(13, 7) = 10000
     LowerL(13, 9) = 0
     UpperL(13, 9) = 1000

     RETURN
  
CondensedMenu:
     SELECT CASE Simulation%                      'Simplified versions
          CASE 5
               GOSUB ActionPotentialMenu
          CASE 6
               GOSUB ExpandedScalesMenu
          CASE 7
               GOSUB DrugMenu
          CASE 8
               GOSUB IonicMenu
          CASE ELSE
     END SELECT

     RETURN

DisplayMenu:
     MenuN = 2
     NumberOfParameters(MenuN) = 8
     MenuTitle$ = "DISPLAY MENU"
     ParamN = 1

     GOSUB GotKey                                 'save screen, print header
     GOSUB PrintDisplayMenu                       'print menu text, values
     CALL PrintSidebar                            'what keys do what
     GOSUB GetInputs                              'change parameters
     IF NextMenu = 0 THEN GOSUB DoneWithMenu      'restore screen

     RETURN
  
StimuliMenu:
     MenuN = 3
     NumberOfParameters(MenuN) = 7
     MenuTitle$ = "STIMULI MEMU"
     ParamN = 1
 
     GOSUB GotKey
     GOSUB PrintStimuliMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

PharmacologyMenu:
     MenuN = 4
     NumberOfParameters(MenuN) = 6
     MenuTitle$ = "PHARMACOLOGY MENU"
     ParamN = 1
  
     GOSUB GotKey
     GOSUB PrintPharmacologyMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

ActionPotentialMenu:
     MenuN = 5
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "ACTION POTENTIAL SIMULATION"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintActionPotentialMenu
     CALL PrintSidebar
     GOSUB GetInputs
     GOSUB DoneWithMenu

     RETURN

ExpandedScalesMenu:
     MenuN = 6
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "EXPANDED SCALES"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintExpandedScalesMenu
     CALL PrintSidebar
     GOSUB GetInputs
     GOSUB DoneWithMenu

     RETURN

DrugMenu:
     MenuN = 7
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "PHARMACOLOGY SIMULATION"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintDrugMenu
     CALL PrintSidebar
     GOSUB GetInputs
     GOSUB DoneWithMenu

     RETURN

IonicMenu:
     MenuN = 8
     NumberOfParameters(MenuN) = 8
     MenuTitle$ = "CHANGES IN ION GRADIENTS"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintIonicMenu
     CALL PrintSidebar
     GOSUB GetInputs
     GOSUB DoneWithMenu

     RETURN

OutputMenu:
     MenuN = 9
     NumberOfParameters(MenuN) = 3
     MenuTitle$ = "OUTPUT MENU"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintOutputMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

MeasureMenu:
     MenuN = 10
     NumberOfParameters(MenuN) = 8
     MenuTitle$ = "MEASUREMENT MENU"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintMeasureMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

nMenu:
     MenuN = 11
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "POTASSIUM CHANNEL (n) KINETICS"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintNMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

mMenu:
     MenuN = 12
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "SODIUM CHANNEL ACTIVATION (m) KINETICS"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintMMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

hMenu:
     MenuN = 13
     NumberOfParameters(MenuN) = 9
     MenuTitle$ = "SODIUM CHANNEL INACTIVATION (h) KINETICS"
     ParamN = 1

     GOSUB GotKey
     GOSUB PrintHMenu
     CALL PrintSidebar
     GOSUB GetInputs
     IF NextMenu = 0 THEN GOSUB DoneWithMenu

     RETURN

PrintDisplayMenu:
     MenuN = 2
     LOCATE 4, OptionCol(1)
     PRINT "UPPER WINDOW - VOLTAGE"
     LOCATE , OptionCol(2)
     PRINT "Normal"
     LOCATE , OptionCol(2)
     PRINT "Expanded"
     CALL PrintDefaultOption(Parameter(MenuN, 1), CSRLIN, 2)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "LOWER WINDOW"
     LOCATE , OptionCol(2)
     PRINT "Conductances"
     LOCATE , OptionCol(2)
     PRINT "Gates"
     LOCATE , OptionCol(2)
     PRINT "Currents - high gain"
     CALL PrintDefaultOption(Parameter(MenuN, 2), CSRLIN, 3)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "TIME SCALE"
     LOCATE , PrintDefaultAt
     CALL PrintNum(TimeOption(Parameter(MenuN, 3)))
     LOCATE , OptionCol(2)
     PRINT "<" + RightArrow$ + "> to increase, <" + LeftArrow$ + "> to decrease"
     LOCATE , OptionCol(3)
     PRINT "[Range:  1 to 1000 ms]"
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Clear screen before EACH sweep";
     CALL PrintTrueOrFalse(Parameter(MenuN, 4))
     LOCATE , OptionCol(2)
     PRINT "Clear screen before NEXT sweep only";
     CALL PrintTrueOrFalse(Parameter(MenuN, 5))

     RETURN

PrintStimuliMenu:
     LOCATE 5, OptionCol(2)
     PRINT "Initial membrane potential (mV)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "FIRST STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "SECOND STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)

     RETURN

PrintPharmacologyMenu:
     LOCATE 5, OptionCol(2)
     PRINT "[Saxitoxin] (nM)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "[TEA] (mM)";
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Percentage of 'h' gates intact";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     PRINT
     PRINT
     LOCATE , OptionCol(0)
     PRINT "ION GRADIENTS - Ratio of external/internal"
     LOCATE , OptionCol(1)
     PRINT " concentrations, as fraction of normal"
     PRINT ""
     LOCATE , OptionCol(2)
     PRINT "Na gradient";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "K gradient";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     PRINT
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Slow calculation rate?";
     CALL PrintTrueOrFalse(Parameter(MenuN, 6))
  
     RETURN

PrintActionPotentialMenu:
     LOCATE 5, OptionCol(2)
     PRINT "Initial membrane potential (mV)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "FIRST STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "SECOND STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Show conductances? (gates otherwise)"
     LOCATE , OptionCol(2)
     PRINT "Clear screen?"

     LOCATE InputLine(MenuN, 8)
     CALL PrintTrueOrFalse(Parameter(MenuN, 8))
     LOCATE InputLine(MenuN, 9)
     CALL PrintTrueOrFalse(Parameter(MenuN, 9))
    
     RETURN

PrintExpandedScalesMenu:
     LOCATE 5, OptionCol(2)
     PRINT "Initial membrane potential (mV)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "FIRST STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "SECOND STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Clear screen before EACH sweep"
     LOCATE , OptionCol(2)
     PRINT "Clear screen before NEXT sweep only"

     LOCATE InputLine(MenuN, 8)
     CALL PrintTrueOrFalse(Parameter(MenuN, 8))
     LOCATE InputLine(MenuN, 9), PrintDefaultAt
     CALL PrintTrueOrFalse(Parameter(MenuN, 9))
     
     RETURN

PrintDrugMenu:
     LOCATE 5, OptionCol(2)
     PRINT "Initial membrane potential (mV)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "BLOCKERS:"
     LOCATE , OptionCol(2)
     PRINT "[Saxitoxin] (nM)";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "[TEA] (mM)";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Percentage of 'h' gates intact";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Long time scale?"
     LOCATE , OptionCol(2)
     PRINT "Clear screen?"

     LOCATE InputLine(MenuN, 8)
     CALL PrintTrueOrFalse(Parameter(MenuN, 8))
     LOCATE InputLine(MenuN, 9)
     CALL PrintTrueOrFalse(Parameter(MenuN, 9))
   
     RETURN

PrintIonicMenu:
     LOCATE 5, OptionCol(2)
     PRINT "Initial membrane potential (mV)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "STIMULUS:"
     LOCATE , OptionCol(2)
     IF HiRes = 4 THEN
          PRINT "Amplitude (uA/cm2)";
     ELSE PRINT "Amplitude (A/cm2)";
     END IF
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Starting time (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Duration (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "CONCENTRATION RATIOS"
     LOCATE , OptionCol(1)
     PRINT "([ext]/[int], as fraction of normal):"
     LOCATE , OptionCol(2)
     PRINT "Na";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "K";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Long time scale?"
     LOCATE , OptionCol(2)
     PRINT "Clear screen?"

     LOCATE InputLine(MenuN, 7)
     CALL PrintTrueOrFalse(Parameter(MenuN, 7))
     LOCATE InputLine(MenuN, 8)
     CALL PrintTrueOrFalse(Parameter(MenuN, 8))
  
     RETURN

PrintOutputMenu:
     LOCATE 5, OptionCol(1)
     PRINT "TYPE OF OUTPUT FILE:"
     PRINT
     LOCATE , OptionCol(2)
     PRINT "None"
     LOCATE , OptionCol(2)
     PRINT ".PRN (text, Lotus-compatible)"
     LOCATE , OptionCol(2)
     PRINT ".DAT (binary, CLAMPEX-compatible)"
     CALL PrintDefaultOption(Parameter(MenuN, 1), CSRLIN, 3)

     RETURN

PrintMeasureMenu:
     LOCATE 4, OptionCol(1)
     PRINT "FIRST MEASUREMENT (peak absolute value)"
     LOCATE , OptionCol(2)
     PRINT "Start at (ms)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "End at";
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "SECOND MEASUREMENT (peak absolute value)"
     LOCATE , OptionCol(2)
     PRINT "Start at";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "End at";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "THIRD MEASUREMENT (maximum value)"
     LOCATE , OptionCol(2)
     PRINT "Start at";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "End at";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "FOURTH MEASUREMENT (minimum value)"
     LOCATE , OptionCol(2)
     PRINT "Start at";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "End at";
     CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
     PRINT

     RETURN

PrintNMenu:
     LOCATE 4, OptionCol(2)
     PRINT "Maximal conductance (mS/cm2)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Exponent on 'n'";
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "OPENING RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Change to exponential form?"
     LOCATE InputLine(MenuN, 6)
     CALL PrintTrueOrFalse(Parameter(MenuN, 6))
     PRINT
     LOCATE , OptionCol(1)
     PRINT "CLOSING RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

     RETURN

PrintMMenu:
     LOCATE 4, OptionCol(2)
     PRINT "Maximal conductance (mS/cm2)";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Exponent on 'm'";
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "OPENING RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Change to exponential form?"
     LOCATE InputLine(MenuN, 6)
     CALL PrintTrueOrFalse(Parameter(MenuN, 6))
     PRINT
     LOCATE , OptionCol(1)
     PRINT "CLOSING RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

     RETURN

PrintHMenu:
     LOCATE 4, OptionCol(2)
     PRINT "Exponent on 'h'";
     CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "RECOVERY RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
     PRINT
     LOCATE , OptionCol(1)
     PRINT "INACTIVATION RATES"
     LOCATE , OptionCol(2)
     PRINT "Constant";
     CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Characteristic voltage";
     CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Voltage sensitivity (mV per e-fold)";
     CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
     LOCATE , OptionCol(2)
     PRINT "Change to exponential form?"
     LOCATE InputLine(MenuN, 8)
     CALL PrintTrueOrFalse(Parameter(MenuN, 8))
     LOCATE , OptionCol(1)
     PRINT "___________________________________"
     PRINT
     LOCATE , OptionCol(2)
     PRINT "Leak conductance (mS/cm2)";
     CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

     RETURN

ChangeDisplayOption:
     SELECT CASE ParamN
          CASE 1 TO 5
               SELECT CASE LCASE$(InputKey$)
                    CASE "n"
                         SELECT CASE ParamN
                              CASE 1
                                   IF ParamN <> Parameter(MenuN, 1) THEN RETURN
                                   Parameter(MenuN, 1) = 2
                                   ParamN = 2
                                   CursorLine = CSRLIN + 1
                              CASE 2
                                   IF ParamN <> Parameter(MenuN, 1) THEN RETURN
                                   Parameter(MenuN, 1) = 1
                                   ParamN = 1
                                   CursorLine = CSRLIN - 1
                              CASE 3
                                   IF ParamN <> Parameter(MenuN, 2) + 2 THEN RETURN
                                   Parameter(MenuN, 2) = 2
                                   ParamN = 4
                                   CursorLine = CSRLIN + 1
                              CASE 4
                                   IF ParamN <> Parameter(MenuN, 2) + 2 THEN RETURN
                                   Parameter(MenuN, 2) = 3
                                   ParamN = 5
                                   CursorLine = CSRLIN + 1
                              CASE 5
                                   IF ParamN <> Parameter(MenuN, 2) + 2 THEN RETURN
                                   Parameter(MenuN, 2) = 1
                                   ParamN = 3
                                   CursorLine = CSRLIN - 2
                              CASE ELSE
                         END SELECT
                         GOSUB RewriteDefault
                    CASE ELSE
                         CursorLine = CSRLIN
                         GOSUB RewriteDefault
                         SELECT CASE ParamN
                              CASE 1
                                   Parameter(MenuN, 1) = 1       'PlotType
                              CASE 2
                                   Parameter(MenuN, 1) = 2
                              CASE 3
                                   Parameter(MenuN, 2) = 1       'LowerPlot
                              CASE 4
                                   Parameter(MenuN, 2) = 2
                              CASE 5
                                   Parameter(MenuN, 2) = 3
                              CASE ELSE
                         END SELECT
               END SELECT
          CASE 7 TO 8
               GOSUB SwitchTrueFalse                   'others
          CASE ELSE
     END SELECT
  
     RETURN

END SUB

