''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'    PARAMC.BAS                                                              '
'                                                                            '
'    Main parameter editing routine for CHANNEL.BAS                          '
'                                                                            '
'    Latest revision 1/6/89 by Stephen W. Jones                              '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'    $INCLUDE: 'declares.inc'
    
	DECLARE SUB PrintOptions ()
	DECLARE SUB PrintResumeKeys ()
	DECLARE SUB RightLabels ()
	DECLARE SUB PrintEditKeys ()
    
	COMMON /ChannelOnly/ Pause

SUB NewParameters STATIC           'Main parameter input and display routine
	SHARED Ega, HiRes, White, Yellow, Blue, Green
	SHARED Simulation%, Called$
	SHARED ReInit, Esc$, MenuN, OutputMenuN
	SHARED PrintDefaultAt
	SHARED Parameter()
	SHARED TimeOption(), IntervalOption()
	SHARED xChar, yChar
	SHARED True, False
	SHARED BackSpace$, Enter$, Down$, Up$, Cursor$, Tab$
	SHARED PgDown$, PgUp$, Home$, End$, F2$, F3$, Null$
	SHARED UpArrow$, DownArrow$
	SHARED RightKey$, LeftKey$, Del$, Ins$
	SHARED xG, yG, InsertMode
	SHARED Pause

	IF NOT DoneAlready THEN                 'Do this first time only
		GOSUB Dimensions
		GOSUB DefineKeys
		GOSUB MakeParameterArrays
	END IF

	MenuOnScreen = None                     'When data on screen, save screen
	RunNow = False                          'Signal to do a new run
	Simple = True                           'One menu only

	IF Pause THEN
		CALL PrintResumeKeys               'If run interrupted
	ELSE CALL PrintOptions
	END IF

anotherKey:
	KeyIn$ = ""                             'Get a key.
	DO WHILE LEN(KeyIn$) = 0
		KeyIn$ = INKEY$
	LOOP
	SELECT CASE LCASE$(KeyIn$)
		CASE "r", F3$                           '<r> = run
			Pause = False
			EXIT SUB
		CASE Esc$, "q"                          '<Esc> = main menu
			Pause = False
			GOSUB QuitMenu
		CASE "i"
			ReInit = True                      '<i> reset values to defaults
			EXIT SUB
		CASE "e", F2$                           '<e> = edit parameters
			Pause = False
			GOSUB CondensedMenu                     'After editing,
			IF RunNow THEN
				EXIT SUB                                'run, or
			ELSE
				CALL Parameters                         'get new key.
				CALL PrintOptions
			END IF
		CASE "c"                                '<c> = continue run
			IF Pause THEN EXIT SUB
		CASE ELSE                               'ignore other keys
	END SELECT
	GOTO anotherKey

	EXIT SUB

'    $INCLUDE: 'param.inc'
  
MakeParameterArrays:
	InputLine(2, 1) = 5           'Display menu
	InputLine(2, 2) = 7
	InputLine(2, 3) = 12
	InputLine(2, 4) = 13
	ParameterToErase(2, 3) = 3         'for rewriting edited values
	ParameterToErase(2, 4) = 3
	LinesToErase(2, 3) = 2
	LinesToErase(2, 4) = 2
 
	ParameterType(2, 1) = ValueType
	ParameterType(2, 2) = ValueType
	FOR i = 3 TO 4
		CursorStart(2, i) = OptionCol(0)
		ParameterType(2, i) = OptionType
	NEXT i
 
	UpperL(2, 1) = 10000
	LowerL(2, 1) = 1
	UpperL(2, 2) = 200
	LowerL(2, 2) = -200

	RETURN

CondensedMenu:
	MenuN = 2
	NumberOfParameters(MenuN) = 4
	MenuTitle$ = "SINGLE CHANNEL CURRENTS"
	ParamN = 1

	GOSUB GotKey                                 'save screen, print header
	GOSUB PrintChannelMenu                       'print menu text, values
	CALL PrintEditKeys                           'what keys do what
	GOSUB GetInputs                              'change parameters
	GOSUB DoneWithMenu                           'restore screen

	RETURN
   
PrintChannelMenu:
	MenuN = 2
	LOCATE 5, OptionCol(2)
	PRINT "Number of sweeps";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	PRINT
	PRINT
	LOCATE , OptionCol(1)
	PRINT "CHANNEL TYPE"
	PRINT
	LOCATE , OptionCol(2)
	PRINT "K channel"
	LOCATE , OptionCol(2)
	PRINT "Na channel"
	LOCATE , OptionCol(2)
	CALL PrintDefaultOption(Parameter(MenuN, 3), CSRLIN, 2)

	RETURN

ChangeDisplayOption:
	SELECT CASE LCASE$(InputKey$)
		CASE "n"
			IF ParamN <> Parameter(MenuN, 3) + 2 THEN RETURN
			SELECT CASE ParamN
				CASE 3
					Parameter(MenuN, 3) = 2            'ChannelType
					ParamN = 4
					CursorLine = CSRLIN + 1
				CASE 4
					Parameter(MenuN, 3) = 1
					ParamN = 3
					CursorLine = CSRLIN - 1
				CASE ELSE
			END SELECT
			GOSUB RewriteDefault
		CASE ELSE
			SELECT CASE ParamN
				CASE 3
					Parameter(MenuN, 3) = 1
				CASE 4
					Parameter(MenuN, 3) = 2
				CASE ELSE
			END SELECT
			CursorLine = CSRLIN
			GOSUB RewriteDefault
	END SELECT

	RETURN

END SUB

