''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'    PARAMV.BAS                                                              '
'                                                                            '
'    Main parameter editing routine for VCLAMP.BAS                           '
'                                                                            '
'    Latest revision 2/25/89 by Stephen W. Jones                             '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'    $INCLUDE: 'declares.inc'

SUB NewParameters STATIC           'Main parameter input and display routine
	SHARED Ega, HiRes, White, Yellow, Blue, Green
	SHARED Simulation%, Called$
	SHARED ReInit, Esc$, MenuN, OutputMenuN
	SHARED PrintDefaultAt
	SHARED Parameter()
	SHARED TimeOption(), IntervalOption()
	SHARED xChar, yChar
	SHARED True, False
	SHARED BackSpace$, Enter$, Down$, Up$, Cursor$, Tab$
	SHARED PgDown$, PgUp$, Home$, End$, F2$, F3$, Null$
	SHARED UpArrow$, DownArrow$
	SHARED RightKey$, LeftKey$, Del$, Ins$
	SHARED xG, yG, InsertMode

	IF NOT DoneAlready THEN                 'Do this first time only
		GOSUB Dimensions
		GOSUB DefineKeys
		GOSUB MakeParameterArrays
	END IF

	Parameter(2, 7) = False                 'ClearNext: Starts false each run
	Parameter(5, 8) = False                 'ClearNext: Starts false each run
	Parameter(6, 8) = False                 'ClearNext: Starts false each run
    
	MenuOnScreen = None                     'When data on screen, save screen
	RunNow = False                          'Signal to do a new run
    
	OutputMenuN = 7                         'These used for menu switches
	LastMenuN = 11                               'new advanced menus
	ExtraValues = 2                              'numbering for Display menu
    
	IF Simulation% >= 2 AND Simulation% <= 3 THEN Simple = True
	IF Simple THEN                               'If simplified version,
		CALL Parameters
		CALL SimulationInstructions                  'print text
anotherKey:
		KeyIn$ = ""
		DO WHILE LEN(KeyIn$) = 0
			KeyIn$ = INKEY$
		LOOP
		SELECT CASE LCASE$(KeyIn$)
			CASE "r", F3$                           '<r> = run
				EXIT SUB
			CASE Esc$, "q"                          '<Esc> = main menu
				GOSUB QuitMenu
			CASE "c"                                '<c> = clear screen
				MenuOnScreen = False
				CLS
				CALL Axes                              'rewrite axes
				CALL Parameters                        'rewrite text
				CALL SimulationInstructions
			CASE "i"
				ReInit = True                      'reset values to defaults
				EXIT SUB
			CASE "e", F2$                           '<e> = edit parameters
				GOSUB CondensedMenu
				IF RunNow THEN
					EXIT SUB                           'run, or
				ELSE CALL Parameters
					CALL SimulationInstructions        'rewrite options
				END IF
			CASE ELSE                               'ignore other keys
		END SELECT
		GOTO anotherKey
	END IF

	CALL MenuInstructions                   'Print help text for menus
doAgain:
	SELECT CASE NextMenu                    'First, test for menu switch
		CASE 2
			NextMenu = 0
			GOSUB DisplayMenu                  'to Display
		CASE 3
			NextMenu = 0
			GOSUB StimuliMenu                  'to Stimuli
		CASE 4
			NextMenu = 0
			GOSUB PharmacologyMenu             'to Pharmacology
		CASE OutputMenuN
			NextMenu = 0
			GOSUB OutputMenu                   'to Outputs
		CASE 8
			NextMenu = 0
			GOSUB MeasureMenu                  'to Measurements
		CASE 9
			NextMenu = 0
			GOSUB nMenu                        'to Potassium kinetics
		CASE 10
			NextMenu = 0
			GOSUB mMenu                        'to Sodium activation
		CASE 11
			NextMenu = 0
			GOSUB hMenu                        'to Sodium inactivation
		CASE ELSE
	END SELECT                              'Next, get new menu choice
	IF NextMenu <> 0 GOTO doAgain                'if not selected already.
 
	IF RunNow THEN EXIT SUB                 'Run (triggered from a menu)

	KeyIn$ = ""
	DO WHILE LEN(KeyIn$) = 0                'Ask for choice of menus
		KeyIn$ = INKEY$
	LOOP

	SELECT CASE LCASE$(KeyIn$)              'Go to appropriate menu,
		CASE "d", "e", F2$
			GOSUB DisplayMenu                       'Display
		CASE "s"
			GOSUB StimuliMenu                       'Stimuli
		CASE "p"
			GOSUB PharmacologyMenu                  'Pharmacology
		CASE "o"
			GOSUB OutputMenu                        'Output
		CASE "a"
			GOSUB MeasureMenu                       'Measurements
		CASE "n"
			GOSUB nMenu                             'Potassium activation
		CASE "m"
			GOSUB mMenu                             'Sodium activation
		CASE "h"
			GOSUB hMenu                             'Sodium inactivation
		CASE "q", Esc$
			GOSUB QuitMenu                     'quit or chain another
		CASE "v"
			CALL Parameters                    'print parameter list
		CASE SpaceBar$, Enter$, F1$
			CALL MenuInstructions              'print hot key list
		CASE "r", F3$
			EXIT SUB                           'do a run
		CASE "c"
			MenuOnScreen = False               'clear screen
			CLS
			CALL Axes                               'redraw axes
			CALL MenuInstructions                   'rewrite text
		CASE "i"
			ReInit = True                      'reset values to defaults
			EXIT SUB
		CASE ELSE
	END SELECT
	GOTO doAgain                                 'or get next key.
 
	EXIT SUB

'    $INCLUDE: 'param.inc'
  
MakeParameterArrays:
	InputLine(2, 1) = 4           'Display menu
	InputLine(2, 2) = 5
	InputLine(2, 3) = 6
	InputLine(2, 4) = 8
	InputLine(2, 5) = 9
	InputLine(2, 6) = 10
	InputLine(2, 7) = 13
	InputLine(2, 8) = 16
	InputLine(2, 9) = 17
	ParameterToErase(2, 1) = 1         'for rewriting edited values
	ParameterToErase(2, 2) = 1
	ParameterToErase(2, 3) = 1
	ParameterToErase(2, 4) = 4
	ParameterToErase(2, 5) = 5
	ParameterToErase(2, 6) = 6
	LinesToErase(2, 1) = 3
	LinesToErase(2, 2) = 3
	LinesToErase(2, 3) = 3
	LinesToErase(2, 4) = 1
	LinesToErase(2, 5) = 1
	LinesToErase(2, 6) = 1
 
	FOR i = 1 TO 9
		CursorStart(2, i) = OptionCol(0)
		ParameterType(2, i) = OptionType
	NEXT i
	ParameterType(2, 7) = MultipleType
 
	TimeOption(1) = 1                  'Available time scales, and
	TimeOption(2) = 2.5
	TimeOption(3) = 5
	TimeOption(4) = 10
	TimeOption(5) = 25
	TimeOption(6) = 50
	TimeOption(7) = 100
	TimeOption(8) = 250
	TimeOption(9) = 500
	TimeOption(10) = 1000

	IntervalOption(1) = 500                 'corresponding # of calculations
	IntervalOption(2) = 500
	IntervalOption(3) = 500
	IntervalOption(4) = 50 * TimeOption(4)
	IntervalOption(5) = 40 * TimeOption(5)
	IntervalOption(6) = 30 * TimeOption(6)
	IntervalOption(7) = 20 * TimeOption(7)
	IntervalOption(8) = 10 * TimeOption(8)
	IntervalOption(9) = 10 * TimeOption(9)
	IntervalOption(10) = 10 * TimeOption(10)
  
	InputLine(3, 1) = 5           'Stimuli menu
	InputLine(3, 2) = 8
	InputLine(3, 3) = 9
	InputLine(3, 4) = 10
	InputLine(3, 5) = 13
	InputLine(3, 6) = 14
	InputLine(3, 7) = 15
	UpperL(3, 1) = 200
	LowerL(3, 1) = -200
	UpperL(3, 2) = 200
	LowerL(3, 2) = -200
	UpperL(3, 3) = 1000
	LowerL(3, 3) = 0
	UpperL(3, 4) = 1000
	LowerL(3, 4) = 0
	UpperL(3, 5) = 200
	LowerL(3, 5) = -200
	UpperL(3, 6) = 1000
	LowerL(3, 6) = 0
	UpperL(3, 7) = 1000
	LowerL(3, 7) = 0

	FOR i = 1 TO 7
		ParameterType(3, i) = ValueType
	NEXT i
		 
	InputLine(4, 1) = 4           'Pharmacology menu
	InputLine(4, 2) = 5
	InputLine(4, 3) = 6
	InputLine(4, 4) = 11
	InputLine(4, 5) = 12
	InputLine(4, 6) = 15
	InputLine(4, 7) = 16
	InputLine(4, 8) = 18
	UpperL(4, 1) = 10000
	LowerL(4, 1) = 0
	UpperL(4, 2) = 10000
	LowerL(4, 2) = 0
	UpperL(4, 3) = 100
	LowerL(4, 3) = 0
	UpperL(4, 4) = 100
	LowerL(4, 4) = .01
	UpperL(4, 5) = 100
	LowerL(4, 5) = .01
	UpperL(4, 6) = 10000
	LowerL(4, 6) = 0
	UpperL(4, 7) = 10000
	LowerL(4, 7) = .0001

	FOR i = 1 TO 7
		ParameterType(4, i) = ValueType
	NEXT i
	ParameterType(4, 8) = OptionType
	CursorStart(4, 8) = OptionCol(0)

	InputLine(5, 1) = 5           'Conductance menu
	InputLine(5, 2) = 8
	InputLine(5, 3) = 9
	InputLine(5, 4) = 10
	InputLine(5, 5) = 13
	InputLine(5, 6) = 14
	InputLine(5, 7) = 15
	InputLine(5, 8) = 17
	UpperL(5, 1) = 120
	LowerL(5, 1) = -120
	UpperL(5, 2) = 120
	LowerL(5, 2) = -120
	UpperL(5, 3) = 1000
	LowerL(5, 3) = 0
	UpperL(5, 4) = 1000
	LowerL(5, 4) = 0
	UpperL(5, 5) = 120
	LowerL(5, 5) = -120
	UpperL(5, 6) = 1000
	LowerL(5, 6) = 0
	UpperL(5, 7) = 1000
	LowerL(5, 7) = 0

	FOR i = 1 TO 7
		ParameterType(5, i) = ValueType
	NEXT i
	ParameterType(5, 8) = OptionType
	CursorStart(5, 8) = OptionCol(0)

	InputLine(6, 1) = 5           'Current menu
	InputLine(6, 2) = 8
	InputLine(6, 3) = 9
	InputLine(6, 4) = 10
	InputLine(6, 5) = 13
	InputLine(6, 6) = 14
	InputLine(6, 7) = 15
	InputLine(6, 8) = 17
	UpperL(6, 1) = 120
	LowerL(6, 1) = -120
	UpperL(6, 2) = 120
	LowerL(6, 2) = -120
	UpperL(6, 3) = 1000
	LowerL(6, 3) = 0
	UpperL(6, 4) = 1000
	LowerL(6, 4) = 0
	UpperL(6, 5) = 120
	LowerL(6, 5) = -120
	UpperL(6, 6) = 1000
	LowerL(6, 6) = 0
	UpperL(6, 7) = 1000
	LowerL(6, 7) = 0

	FOR i = 1 TO 7
		ParameterType(6, i) = ValueType
	NEXT i
	ParameterType(6, 8) = OptionType
	CursorStart(6, 8) = OptionCol(0)

	InputLine(7, 1) = 7                'Output menu
	InputLine(7, 2) = 8
	InputLine(7, 3) = 9
	FOR i = 1 TO 3
		ParameterType(7, i) = OptionType
		CursorStart(7, i) = OptionCol(0)
	NEXT i
 
	ParameterToErase(7, 1) = 1
	ParameterToErase(7, 2) = 1
	ParameterToErase(7, 3) = 1
	LinesToErase(7, 1) = 3
	LinesToErase(7, 2) = 3
	LinesToErase(7, 3) = 3

	FOR i = 1 TO 8                     'Measurements menu
		ParameterType(8, i) = ValueType
	NEXT i
	InputLine(8, 1) = 5
	InputLine(8, 2) = 6
	InputLine(8, 3) = 9
	InputLine(8, 4) = 10
	InputLine(8, 5) = 13
	InputLine(8, 6) = 14
	InputLine(8, 7) = 17
	InputLine(8, 8) = 18
	FOR i = 1 TO 8
		LowerL(8, i) = 0
		UpperL(8, i) = 1000
	NEXT i

	FOR i = 1 TO 9                     'n kinetics menu
		ParameterType(9, i) = ValueType
	NEXT i
	ParameterType(9, 6) = OptionType
	CursorStart(9, 6) = OptionCol(0)

	InputLine(9, 1) = 4
	InputLine(9, 2) = 5
	InputLine(9, 3) = 8
	InputLine(9, 4) = 9
	InputLine(9, 5) = 10
	InputLine(9, 6) = 11
	InputLine(9, 7) = 14
	InputLine(9, 8) = 15
	InputLine(9, 9) = 16
   
	LowerL(9, 1) = 0
	UpperL(9, 1) = 1000
	LowerL(9, 2) = 0
	UpperL(9, 2) = 100
	LowerL(9, 3) = 0
	UpperL(9, 3) = 1000
	LowerL(9, 4) = -200
	UpperL(9, 4) = 200
	LowerL(9, 5) = -10000
	UpperL(9, 5) = 10000
	LowerL(9, 7) = 0
	UpperL(9, 7) = 1000
	LowerL(9, 8) = -200
	UpperL(9, 8) = 200
	LowerL(9, 9) = -10000
	UpperL(9, 9) = 10000

	FOR i = 1 TO 9                     'm kinetics menu
		ParameterType(10, i) = ValueType
	NEXT i
	ParameterType(10, 6) = OptionType
	CursorStart(10, 6) = OptionCol(0)

	InputLine(10, 1) = 4
	InputLine(10, 2) = 5
	InputLine(10, 3) = 8
	InputLine(10, 4) = 9
	InputLine(10, 5) = 10
	InputLine(10, 6) = 11
	InputLine(10, 7) = 14
	InputLine(10, 8) = 15
	InputLine(10, 9) = 16
   
	LowerL(10, 1) = 0
	UpperL(10, 1) = 1000
	LowerL(10, 2) = 0
	UpperL(10, 2) = 100
	LowerL(10, 3) = 0
	UpperL(10, 3) = 1000
	LowerL(10, 4) = -200
	UpperL(10, 4) = 200
	LowerL(10, 5) = -10000
	UpperL(10, 5) = 10000
	LowerL(10, 7) = 0
	UpperL(10, 7) = 1000
	LowerL(10, 8) = -200
	UpperL(10, 8) = 200
	LowerL(10, 9) = -10000
	UpperL(10, 9) = 10000
					
	FOR i = 1 TO 9                     'h kinetics menu
		ParameterType(11, i) = ValueType
	NEXT i
	ParameterType(11, 8) = OptionType
	CursorStart(11, 8) = OptionCol(0)

	InputLine(11, 1) = 4
	InputLine(11, 2) = 7
	InputLine(11, 3) = 8
	InputLine(11, 4) = 9
	InputLine(11, 5) = 12
	InputLine(11, 6) = 13
	InputLine(11, 7) = 14
	InputLine(11, 8) = 15
	InputLine(11, 9) = 18
  
	LowerL(11, 1) = 0
	UpperL(11, 1) = 100
	LowerL(11, 2) = 0
	UpperL(11, 2) = 1000
	LowerL(11, 3) = -200
	UpperL(11, 3) = 200
	LowerL(11, 4) = -10000
	UpperL(11, 4) = 10000
	LowerL(11, 5) = 0
	UpperL(11, 5) = 1000
	LowerL(11, 6) = -200
	UpperL(11, 6) = 200
	LowerL(11, 7) = -10000
	UpperL(11, 7) = 10000
	LowerL(11, 9) = 0
	UpperL(11, 9) = 1000
    
	RETURN

CondensedMenu:
	SELECT CASE Simulation%                 'for simplified versions
		CASE 2
			GOSUB ConductanceMenu
		CASE 3
			GOSUB CurrentMenu
		CASE ELSE
	END SELECT

	RETURN

DisplayMenu:
	MenuN = 2
	NumberOfParameters(MenuN) = 9
	MenuTitle$ = "DISPLAY MENU"
	ParamN = 1

	GOSUB GotKey                                 'save screen, print header
	GOSUB PrintDisplayMenu                       'print menu text, values
	CALL PrintSidebar                            'what keys do what
	GOSUB GetInputs                              'change parameters
	IF NextMenu = 0 THEN GOSUB DoneWithMenu      'restore screen

	RETURN
   
StimuliMenu:
	MenuN = 3
	NumberOfParameters(MenuN) = 7
	MenuTitle$ = "VOLTAGE COMMAND MENU"
	ParamN = 1
  
	GOSUB GotKey
	GOSUB PrintStimuliMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

PharmacologyMenu:
	MenuN = 4
	NumberOfParameters(MenuN) = 8
	MenuTitle$ = "PHARMACOLOGY MENU"
	ParamN = 1
   
	GOSUB GotKey
	GOSUB PrintPharmacologyMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

ConductanceMenu:
	MenuN = 5
	NumberOfParameters(MenuN) = 8
	MenuTitle$ = "VOLTAGE-DEPENDENT CONDUCTANCES"
	ParamN = 1
 
	GOSUB GotKey
	GOSUB PrintConductanceMenu
	CALL PrintSidebar
	GOSUB GetInputs
	GOSUB DoneWithMenu

	RETURN

CurrentMenu:
	MenuN = 6
	NumberOfParameters(MenuN) = 8
	MenuTitle$ = "VOLTAGE-DEPENDENT CURRENTS"
	ParamN = 1
 
	GOSUB GotKey
	GOSUB PrintCurrentMenu
	CALL PrintSidebar
	GOSUB GetInputs
	GOSUB DoneWithMenu

	RETURN

OutputMenu:
	MenuN = 7
	NumberOfParameters(MenuN) = 3
	MenuTitle$ = "OUTPUT MENU"
	ParamN = 1

	GOSUB GotKey
	GOSUB PrintOutputMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

MeasureMenu:
	MenuN = 8
	NumberOfParameters(MenuN) = 8
	MenuTitle$ = "MEASUREMENT MENU"
	ParamN = 1

	GOSUB GotKey
	GOSUB PrintMeasureMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

nMenu:
	MenuN = 9
	NumberOfParameters(MenuN) = 9
	MenuTitle$ = "POTASSIUM CHANNEL (n) KINETICS"
	ParamN = 1

	GOSUB GotKey
	GOSUB PrintNMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

mMenu:
	MenuN = 10
	NumberOfParameters(MenuN) = 9
	MenuTitle$ = "SODIUM CHANNEL ACTIVATION (m) KINETICS"
	ParamN = 1

	GOSUB GotKey
	GOSUB PrintMMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

hMenu:
	MenuN = 11
	NumberOfParameters(MenuN) = 9
	MenuTitle$ = "SODIUM CHANNEL INACTIVATION (h) KINETICS"
	ParamN = 1

	GOSUB GotKey
	GOSUB PrintHMenu
	CALL PrintSidebar
	GOSUB GetInputs
	IF NextMenu = 0 THEN GOSUB DoneWithMenu

	RETURN

PrintDisplayMenu:
	MenuN = 2
	LOCATE 4, OptionCol(2)
	PRINT "Conductances"
	LOCATE , OptionCol(2)
	PRINT "Currents"
	LOCATE , OptionCol(2)
	PRINT "Gates"
	CALL PrintDefaultOption(Parameter(MenuN, 1), CSRLIN, 3)
   
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Show Na?";
	CALL PrintTrueOrFalse(Parameter(MenuN, 2))
	LOCATE , OptionCol(2)
	PRINT "Show K?";
	CALL PrintTrueOrFalse(Parameter(MenuN, 3))
	LOCATE , OptionCol(2)
	PRINT "Show total current?";
	CALL PrintTrueOrFalse(Parameter(MenuN, 4))
	PRINT
	LOCATE , OptionCol(1)
	PRINT "TIME SCALE"
	LOCATE , PrintDefaultAt
	CALL PrintNum(TimeOption(Parameter(MenuN, 5)))
	LOCATE , OptionCol(2)
	PRINT "<" + RightArrow$ + "> to increase, <" + LeftArrow$ + "> to decrease"
	LOCATE , OptionCol(3)
	PRINT "[Range:  1 to 1000 ms]"
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Clear screen before EACH sweep";
	CALL PrintTrueOrFalse(Parameter(MenuN, 6))
	LOCATE , OptionCol(2)
	PRINT "Clear screen before NEXT sweep";
	CALL PrintTrueOrFalse(Parameter(MenuN, 7))

	RETURN

PrintStimuliMenu:
	LOCATE 5, OptionCol(2)
	PRINT "Holding potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "FIRST COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "SECOND COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
 
	RETURN

PrintPharmacologyMenu:
	LOCATE 4, OptionCol(2)
	PRINT "[Saxitoxin] (nM)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "[TEA] (mM)";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Percentage of 'h' gates intact";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	PRINT
	LOCATE , OptionCol(0)
	PRINT "ION GRADIENTS - Ratio of external/internal"
	LOCATE , OptionCol(1)
	PRINT " concentrations, as fraction of normal"
	PRINT ""
	LOCATE , OptionCol(2)
	PRINT "Na gradient";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "K gradient";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "VOLTAGE CLAMP QUALITY"
	LOCATE , OptionCol(2)
	IF HiRes = 4 THEN
		PRINT "Series resistance (Ohm cm2)";
	ELSE PRINT "Series resistance (cm2)";
	END IF
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	LOCATE , OptionCol(2)
	IF HiRes = 4 THEN
		PRINT "Membrane capacitance (uF/cm2)";
	ELSE PRINT "Membrane capacitance (F/cm2)";
	END IF
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Slow calculation rate?";
	CALL PrintTrueOrFalse(Parameter(MenuN, 8))

	RETURN

PrintConductanceMenu:
	LOCATE 5, OptionCol(2)
	PRINT "Holding potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "FIRST COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "SECOND COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Clear screen?"
   
	LOCATE InputLine(MenuN, 8)
	CALL PrintTrueOrFalse(Parameter(MenuN, 8))

	RETURN

PrintCurrentMenu:
	LOCATE 5, OptionCol(2)
	PRINT "Holding potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "FIRST COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "SECOND COMMAND:"
	LOCATE , OptionCol(2)
	PRINT "Membrane potential (mV)";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Starting time (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Duration (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Clear screen?"
  
	LOCATE InputLine(MenuN, 8)
	CALL PrintTrueOrFalse(Parameter(MenuN, 8))

	RETURN

PrintOutputMenu:
	LOCATE 5, OptionCol(1)
	PRINT "TYPE OF OUTPUT FILE:"
	PRINT
	LOCATE , OptionCol(2)
	PRINT "None"
	LOCATE , OptionCol(2)
	PRINT ".PRN (text, Lotus-compatible)"
	LOCATE , OptionCol(2)
	PRINT ".DAT (binary, CLAMPEX-compatible)"
	CALL PrintDefaultOption(Parameter(MenuN, 1), CSRLIN, 3)

	RETURN

PrintMeasureMenu:
	LOCATE 4, OptionCol(1)
	PRINT "FIRST MEASUREMENT (peak absolute value)"
	LOCATE , OptionCol(2)
	PRINT "Start at (ms)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "End at";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "SECOND MEASUREMENT (peak absolute value)"
	LOCATE , OptionCol(2)
	PRINT "Start at";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "End at";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "THIRD MEASUREMENT (maximum value)"
	LOCATE , OptionCol(2)
	PRINT "Start at";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "End at";
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "FOURTH MEASUREMENT (minimum value)"
	LOCATE , OptionCol(2)
	PRINT "Start at";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "End at";
	CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
	PRINT

	RETURN
    
PrintNMenu:
	LOCATE 4, OptionCol(2)
	PRINT "Maximal conductance (mS/cm2)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Exponent on 'n'";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "OPENING RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Change to exponential form?"
	LOCATE InputLine(MenuN, 6)
	CALL PrintTrueOrFalse(Parameter(MenuN, 6))
	PRINT
	LOCATE , OptionCol(1)
	PRINT "CLOSING RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

	RETURN

PrintMMenu:
	LOCATE 4, OptionCol(2)
	PRINT "Maximal conductance (mS/cm2)";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Exponent on 'm'";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "OPENING RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Change to exponential form?"
	LOCATE InputLine(MenuN, 6)
	CALL PrintTrueOrFalse(Parameter(MenuN, 6))
	PRINT
	LOCATE , OptionCol(1)
	PRINT "CLOSING RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 8), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

	RETURN

PrintHMenu:
	LOCATE 4, OptionCol(2)
	PRINT "Exponent on 'h'";
	CALL PrintDefaultValue(Parameter(MenuN, 1), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "RECOVERY RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 2), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 3), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 4), CSRLIN)
	PRINT
	LOCATE , OptionCol(1)
	PRINT "INACTIVATION RATES"
	LOCATE , OptionCol(2)
	PRINT "Constant";
	CALL PrintDefaultValue(Parameter(MenuN, 5), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Characteristic voltage";
	CALL PrintDefaultValue(Parameter(MenuN, 6), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Voltage sensitivity (mV per e-fold)";
	CALL PrintDefaultValue(Parameter(MenuN, 7), CSRLIN)
	LOCATE , OptionCol(2)
	PRINT "Change to exponential form?"
	LOCATE InputLine(MenuN, 8)
	CALL PrintTrueOrFalse(Parameter(MenuN, 8))
	LOCATE , OptionCol(1)
	PRINT "___________________________________"
	PRINT
	LOCATE , OptionCol(2)
	PRINT "Leak conductance (mS/cm2)";
	CALL PrintDefaultValue(Parameter(MenuN, 9), CSRLIN)

	RETURN

ChangeDisplayOption:
	SELECT CASE ParamN
		CASE 1 TO 3
			SELECT CASE LCASE$(InputKey$)
				CASE "n"
					IF ParamN <> Parameter(MenuN, 1) THEN RETURN
					SELECT CASE ParamN
						CASE 1
							Parameter(MenuN, 1) = 2  'PlotType
							ParamN = 2
							CursorLine = CSRLIN + 1
						CASE 2
							Parameter(MenuN, 1) = 3
							ParamN = 3
							CursorLine = CSRLIN + 1
						CASE 3
							Parameter(MenuN, 1) = 1
							ParamN = 1
							CursorLine = CSRLIN - 2
						CASE ELSE
					END SELECT
					GOSUB RewriteDefault
				CASE ELSE
					SELECT CASE ParamN
						CASE 1
							Parameter(MenuN, 1) = 1  'PlotType
						CASE 2
							Parameter(MenuN, 1) = 2
						CASE 3
							Parameter(MenuN, 1) = 3
						CASE ELSE
					END SELECT
					CursorLine = CSRLIN
					GOSUB RewriteDefault
			END SELECT
		CASE 4 TO 6                             'PlotNa, PlotK, PlotTotal
			GOSUB SwitchTrueFalse
		CASE 8 TO 9                             'ClearNext, ClearScreen
			GOSUB SwitchTrueFalse
		CASE ELSE
	END SELECT

	RETURN

END SUB

