''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'    POKEINFO.INC                                                            '
'                                                                            '
'    Writes information to a "communication area" in memory,                 '
'         to pass parameters between programs.                               '
'    This avoids using COMMON, which seemed to introduce bugs.               '
'                                                                            '
'    Used by menu programs in the AXOVACS package.                           '
'                                                                            '
'    Revised 12/31/88 by Stephen W. Jones                                    '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

PokeInfo:
     SafetyCheck$ = "axovacs"                          'data written by AXOVACS
     Simulation$ = RIGHT$(STR$(Simulation%), 1)             'desired option
                                                            'calling program
     PokeText$ = SafetyCheck$ + Simulation$ + Called$
     IF Called$ = "" THEN PokeText$ = ""               'clear area if exit
     WHILE LEN(PokeText$) < 16
          PokeText$ = PokeText$ + " "
     WEND

     DEF SEG = &H4F                                    '16 byte data area
     FOR i = 1 TO 16
          Char$ = MID$(PokeText$, i, 1)
          PokeData = ASC(Char$)                        'written as integers
          IF PokeData > 255 THEN PokeData = 255
          POKE i - 1, PokeData
     NEXT i

     DEF SEG

     RETURN

